% This function mxNiDepth, takes the Current-Depth (movie) frame from 
%   the Kinect-Stream, and makes it available as matlab variable
%
% 	D = mxNiDepth(KinectHandles);
%
% inputs,
%   KinectHandles : Array with pointers to kinect node objects generated by
%          mxNiCreateContext, such as main, image, IR, Depth and User node.
%
% outputs,
%   D : A 2D Matrix of type Uint16 with Depth information. 
%       This depth is not in world-coordinates, if you want
%       World-coordinates use mxNiDepthRealWorld.
%
% note,
%	To go the next movie-frame use mxNiUpdateContext(KinectHandles)
%
%
% See also mxNiDepthRealWorld, mxNiCreateContext, mxNiUpdateContext, 
%       mxNiPhoto, mxNiInfrared, mxNiSkeleton, mxNiDeleteContext
%
% Mex-Wrapper is written by D.Kroon University of Twente (February 2011)  
